package org.mercury_im.messenger.persistence.room.dao;

import androidx.annotation.WorkerThread;
import androidx.room.Dao;
import androidx.room.Query;

import org.mercury_im.messenger.persistence.room.model.RoomEntityCapsModel;

import java.util.List;

import io.reactivex.Completable;
import io.reactivex.Observable;
import io.reactivex.Single;

@Dao
@WorkerThread
public interface EntityCapsDao extends BaseDao<RoomEntityCapsModel> {

    @Query("SELECT * FROM entity_caps WHERE pk_node_ver = :nodeVer")
    Single<RoomEntityCapsModel> getEntityCapsForNodeVer(String nodeVer);

    @Query("SELECT * FROM entity_caps")
    Observable<List<RoomEntityCapsModel>> getAllEntityCaps();

    @Query("DELETE FROM entity_caps")
    Completable deleteAllEntityCaps();
}
