package org.mercury_im.messenger.persistence.room.dao;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.TypeConverters;

import org.jxmpp.jid.EntityBareJid;
import org.mercury_im.messenger.persistence.room.model.RoomEntityModel;
import org.mercury_im.messenger.persistence.room.type_converter.EntityBareJidConverter;

import io.reactivex.Maybe;
import io.reactivex.Single;

import static androidx.room.OnConflictStrategy.REPLACE;

@Dao
@TypeConverters(EntityBareJidConverter.class)
public interface EntityDao extends BaseDao<RoomEntityModel> {

    @Query("SELECT * FROM entities WHERE pk_entity_id = :id")
    Maybe<RoomEntityModel> getEntity(long id);

    @Query("SELECT * FROM entities WHERE fk_account_id = :accountId AND jid = :jid")
    Maybe<RoomEntityModel> getEntityFor(long accountId, EntityBareJid jid);
}
