package org.mercury_im.messenger.persistence.room.model;

import androidx.annotation.NonNull;
import androidx.room.ColumnInfo;
import androidx.room.Entity;
import androidx.room.PrimaryKey;

import org.mercury_im.messenger.persistence.model.EntityCapsModel;

import static org.mercury_im.messenger.persistence.room.model.RoomEntityCapsModel.TABLE;

@Entity(tableName = TABLE)
public class RoomEntityCapsModel implements EntityCapsModel {

    public static final String TABLE = "entity_caps";
    public static final String KEY_NODE_VER = "pk_node_ver";
    public static final String KEY_XML = "xml";

    @PrimaryKey
    @NonNull
    @ColumnInfo(name = KEY_NODE_VER, index = true)
    private String nodeVer;

    @ColumnInfo(name = KEY_XML)
    private String xml;

    public RoomEntityCapsModel(@NonNull String nodeVer) {
        this.nodeVer = nodeVer;
    }

    @Override
    @NonNull
    public String getNodeVer() {
        return nodeVer;
    }

    @Override
    public void setNodeVer(@NonNull String nodeVer) {
        this.nodeVer = nodeVer;
    }

    @Override
    public String getXml() {
        return xml;
    }

    @Override
    public void setXml(String xml) {
        this.xml = xml;
    }
}
