package org.mercury_im.messenger.persistence.room.repository;

import androidx.annotation.NonNull;

import org.mercury_im.messenger.persistence.repository.EntityCapsRepository;
import org.mercury_im.messenger.persistence.room.dao.EntityCapsDao;
import org.mercury_im.messenger.persistence.room.model.RoomEntityCapsModel;

import java.util.List;

import javax.inject.Inject;

import io.reactivex.Completable;
import io.reactivex.Observable;
import io.reactivex.Single;


public class IEntityCapsRepository implements EntityCapsRepository<RoomEntityCapsModel> {

    private final EntityCapsDao dao;

    @Inject
    public IEntityCapsRepository(EntityCapsDao dao) {
        this.dao = dao;
    }

    @Override
    public RoomEntityCapsModel newEntityCapsModel(@NonNull String nodeVer) {
        return new RoomEntityCapsModel(nodeVer);
    }

    @Override
    public Observable<List<RoomEntityCapsModel>> getAllEntityCaps() {
        return dao.getAllEntityCaps();
    }

    @Override
    public Single<RoomEntityCapsModel> getEntityCapsForNodeVer(String nodeVer) {
        return dao.getEntityCapsForNodeVer(nodeVer);
    }

    @Override
    public Single<List<Long>> insertOrReplaceEntityCaps(List<RoomEntityCapsModel> entityCaps) {
        return dao.insert(entityCaps);
    }

    @Override
    public Single<Long> insertOrReplaceEntityCaps(RoomEntityCapsModel entityCaps) {
        return dao.insert(entityCaps);
    }

    @Override
    public Completable deleteOrReplaceEntityCaps(List<RoomEntityCapsModel> entityCaps) {
        return dao.delete(entityCaps);
    }

    @Override
    public Completable deleteOrReplaceEntityCaps(RoomEntityCapsModel entityCaps) {
        return dao.delete(entityCaps);
    }

    @Override
    public Completable deleteAllEntityCaps() {
        return dao.deleteAllEntityCaps();
    }
}
