package org.mercury_im.messenger.persistence.room.type_converter;

import androidx.room.TypeConverter;

import org.jxmpp.jid.EntityBareJid;
import org.jxmpp.jid.impl.JidCreate;
import org.jxmpp.stringprep.XmppStringprepException;

public class EntityBareJidConverter {

    @TypeConverter
    public static String toString(EntityBareJid jid) {
        return jid != null ? jid.toString() : null;
    }

    @TypeConverter
    public static EntityBareJid toEntityBareJid(String string) {
        try {
            return string != null ? JidCreate.entityBareFrom(string) : null;
        } catch (XmppStringprepException e) {
            e.printStackTrace();
            return null;
        }
    }
}
